﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using FarPoint.Excel;

namespace Spread_Win_OpenExcel_Stream
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            var warningListStream = new ExcelWarningList();
            var warningListFile = new ExcelWarningList();
            var flag = ExcelOpenFlags.NoFlagsSet;
            var f = @"..\..\Conditional formatting with formula.xlsx";
            //var f = @"..\..\Conditional formatting with formula_old.xls";

            System.IO.FileStream s = new System.IO.FileStream(f, System.IO.FileMode.Open, System.IO.FileAccess.Read);
            try
            {
                fpSpread1.OpenExcel(s, flag, warningListStream,null,true);
                s.Close();
                fpSpread2.OpenExcel(f, flag, warningListFile,null,true);
                MessageWarnings(warningListStream, warningListFile);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

        }

        private void MessageWarnings(ExcelWarningList warningListStream, ExcelWarningList warningListFile)
        {
            if(warningListStream.Count==0 && warningListFile.Count==0)
                return;

            var messagefinalMessage = "Warnings in loading stream & file" + Environment.NewLine;
            messagefinalMessage += "---Stream----" + Environment.NewLine;
            foreach (var message in warningListStream.WarningList)
                messagefinalMessage += "Code:" + ((ExcelWarning)message).Code+ " Message:"+ ((ExcelWarning)message).Message + Environment.NewLine;
            
            messagefinalMessage += "---File----" + Environment.NewLine;
            foreach (var message in warningListFile.WarningList)
                messagefinalMessage += "Code:" + ((ExcelWarning)message).Code + " Message:" + ((ExcelWarning)message).Message + Environment.NewLine;

            MessageBox.Show(messagefinalMessage);
        }
    }
}
